﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Commanding
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            // vastaava kuin save-komennolle tehty commandbinding xamlin puolella
            CommandBinding OpenCmdBinding = new CommandBinding(
                ApplicationCommands.Open,
                OpenCmdExecuted,
                OpenCmdCanExecute);

            this.CommandBindings.Add(OpenCmdBinding);

            // lisätään ctrl-o näppäinoikotie vastaavaan file|open-komentoa. save-komennolle on tehty
            // sama xamlissa
            KeyGesture OpenKeyGesture = new KeyGesture(
                Key.O,
                ModifierKeys.Control);

            KeyBinding OpenCmdKeybinding = new KeyBinding(
                ApplicationCommands.Open,
                OpenKeyGesture);

            this.InputBindings.Add(OpenCmdKeybinding);


        }
        // tapahtuu jos save suoritetaan
        void SaveCmdExecuted(object target, ExecutedRoutedEventArgs e)
        {
            String command, targetobj;
            command = ((RoutedCommand)e.Command).Name;
            targetobj = ((FrameworkElement)target).Name;
            MessageBox.Show("The " + command + " command has been invoked on target object " + targetobj);
        }

        // jos open suoritetaan
        void OpenCmdExecuted(object target, ExecutedRoutedEventArgs e)
        {
            String command, targetobj;
            command = ((RoutedCommand)e.Command).Name;
            targetobj = ((FrameworkElement)target).Name;
            MessageBox.Show("The " + command + " command has been invoked on target object " + targetobj);
        }

        // voidaanko open tehdä? linkitetty suoraan näytöllä olevaan checkboxiin
        void OpenCmdCanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            e.CanExecute = (bool)open.IsChecked;
        }

        // voidaanko save tehdä? linkitetty suoraan näytöllä olevaan checkboxiin
        void SaveCmdCanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            e.CanExecute = (bool)save.IsChecked;
        }
    }
}
